<form [formGroup]="userForm"  (ngSubmit)="onSave()">
    <table>
        <tr>
            <th>Name</th>
            <td colspan="2">
                <input type="text" [formControl]="nameCtrl"/>
            </td>
        </tr>
        <tr>
            <th></th>
            <td class="error">
                <ul *ngIf="nameCtrl.dirty && nameCtrl.invalid">
                    <li *ngIf="nameCtrl.errors.required">Must provide a value
                    </li>
                    <li *ngIf="nameCtrl.errors.minlength">
                        At
                        least {{nameCtrl.errors.minlength.requiredLength || '?'}}
                        chars
                    </li>
                    <li *ngIf="nameCtrl.errors.maxlength">At most 10 chars</li>
                </ul>
            </td>
            <td>
                <pre *ngIf="nameCtrl.errors">{{nameCtrl.errors | json}}</pre>
            </td>
        </tr>

        <tr>
            <th>Age</th>
            <td colspan="2">
                <input type="number" [formControl]="ageCtrl"/>
            </td>
        </tr>
        <tr>
            <th></th>
            <td class="error">
                <ul *ngIf="ageCtrl.dirty && ageCtrl.invalid">
                    <li *ngIf="ageCtrl.errors.required">
                        Must provide a value
                    </li>
                    <li *ngIf="ageCtrl.errors.min">
                        Not younger than 20
                    </li>
                    <li *ngIf="ageCtrl.errors.min">
                        Not older than 80
                    </li>
                </ul>
            </td>
            <td>
                <pre *ngIf="ageCtrl.errors">{{ageCtrl.errors | json}}</pre>
            </td>
        </tr>

        <tr>
            <th>Female</th>
            <td colspan="2">
                <input type="checkbox" [formControl]="femaleCtrl" />
            </td>
        </tr>
        <tr>
            <th></th>
            <td></td>
            <td>
                <pre *ngIf="femaleCtrl.errors">{{femaleCtrl.errors | json}}</pre>
            </td>
        </tr>

        <tr>
            <th>Anniversary</th>
            <td colspan="2">
                <input type="date" [formControl]="anniversaryCtrl" />
            </td>
        </tr>
        <tr>
            <th></th>
            <td>
                <ul *ngIf="anniversaryCtrl.dirty && anniversaryCtrl.invalid">
                    <li *ngIf="anniversaryCtrl.errors.required">
                        Must provide a value
                    </li>
                </ul>
            </td>
            <td>
                <pre *ngIf="anniversaryCtrl.errors">{{anniversaryCtrl.errors | json}}</pre>
            </td>
        </tr>
    </table>

    <div class="buttons">
        <button [disabled]="userForm.invalid" (click)="onSave()">SAVE</button>
        <button (click)="onCancel()">Cancel</button>
    </div>
</form>
